/* global $, odkTables, odkData, odkCommon */
'use strict';

var tramkastListResultSet = {};

function cbSuccess(result) {
    tramkastListResultSet = result;

    displayGroup();
}

function cbFailure(error) {
    console.log('tramkast_list: cbFailure failed with error: ' + error);
}

function doSearch() {
    var searchText = $("#searchForText").val();
    if (searchText == "") {
        setup();        
        console.log("i searched for nothing ");
    } else {
        searchText = "%" + searchText + "%";
        odkData.query("tramkast", "tramkast_id like ?", [searchText], null, null, null, null, null, null, true, cbSuccess, cbFailure);
        console.log("i searched for " + searchText);
    }
}


function setup() {
    odkData.getViewData(cbSuccess, cbFailure);
    $("#searchForText").change(doSearch);
}
        
function handleClick(index) {
    var tableId = tramkastListResultSet.getTableId();
    var rowId = tramkastListResultSet.getRowId(index);
    odkTables.openDetailView(null, tableId, rowId, null);
}

var imgHeight;
var imgWidth;

function showImage(imgPath) {
    var myImage = new Image();
    myImage.name = imgPath;
    myImage.onload = function () {
		imgHeight = this.height;
		imgWidth = this.width;
		return true;
	};
    myImage.src = imgPath;
}

function displayGroup() {
    $("#wrapper").empty();
    // Ensure that this is the first displayed in the list
    var mapIndex = tramkastListResultSet.getMapIndex();
    
    // Make sure that it is valid
    if (mapIndex !== null && mapIndex !== undefined) {
        // Make sure that it is not invalid 
        if (mapIndex !== -1) {
            // Make this the first item in the list
            addDataForRow(mapIndex);
        }
    }

    for (var i = 0; i < tramkastListResultSet.getCount(); i++) {
        // Make sure not to repeat the selected item if one existed
        if (i === mapIndex) {
            continue;
        }

        addDataForRow(i);
    }
}



function addDataForRow(rowNumber) {
    /*    Creating the item space    */
    var itemHeading = $('<p>');
    itemHeading.text(tramkastListResultSet.getData(rowNumber, 'tramkast_id'));
    itemHeading.attr('class', 'heading');
    
    var detailContainer = $('<div>');
    detailContainer.attr('onclick', 'handleClick(' + rowNumber + ')');
    detailContainer.attr('class', 'detail_container');
    detailContainer.attr('id', 'item_' + rowNumber);
    $(detailContainer).hide();
              
    var lat = tramkastListResultSet.getData(rowNumber,'Location_tramkast_latitude');
    var lng = tramkastListResultSet.getData(rowNumber,'Location_tramkast_longitude');
    var tech = tramkastListResultSet.getData(rowNumber,'PDST_TECHNOLOGY');

    var field1 = $('<p>');
    field1.text('Latitude: ' + lat);
    var field2 = $('<p>');
    field2.text('Longitude: ' + lng);
    var field3 = $('<p>');
    field3.text('Technology: ' + tech);
    
    var uriRelative = tramkastListResultSet.getData(rowNumber, 'tramkastpic_inside.uriFragment');
    var src = '';
    if (uriRelative !== null  && uriRelative !== '') {
        var tableId = tramkastListResultSet.getTableId();
        var rowId = tramkastListResultSet.getRowId(rowNumber);
        var uriAbsolute = odkCommon.getRowFileAsUrl(tableId, rowId, uriRelative);
        src = uriAbsolute;
    }

    var thumbnail = $('<img>');
    thumbnail.attr('src', src);
    thumbnail.attr('class', 'thumbnail');
    var buffer = $('<p>');
    buffer.attr('class', 'clear');

    detailContainer.append(thumbnail);
    detailContainer.append(field1);
    detailContainer.append(field2);
    detailContainer.append(buffer);
    
    $(itemHeading).click(function()
    {
        if($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        } else {
            $(this).addClass('selected');
        }
        $(this).next(detailContainer).slideToggle('slow');
    });
    
    $('#wrapper').append(itemHeading);
    $('#wrapper').append(detailContainer);
}
